=== modified file 'NEWS'
--- NEWS	2009-05-16 08:21:11 +0000
+++ NEWS	2009-05-18 21:48:44 +0000
@@ -9,6 +9,33 @@
 In Development
 ##############
 
+Compatibility Breaks
+********************
+
+New Features
+************
+
+Improvements
+************
+
+Bug Fixes
+*********
+
+Documentation
+*************
+
+API Changes
+***********
+
+* Added osutils.parent_directories(). (Ian Clatworthy)
+
+Internals
+*********
+
+Testing
+*******
+
+
 bzr 1.15
 ########
 :1.15rc1: 2009-04-06

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2009-05-16 08:21:11 +0000
+++ bzrlib/osutils.py	2009-05-18 21:48:44 +0000
@@ -867,6 +867,19 @@
     return pathjoin(*p)
 
 
+def parent_directories(filename):
+    """Return the list of parent directories, deepest first.
+    
+    For example, parent_directories("a/b/c") -> ["a/b", "a"].
+    """
+    parents = []
+    parts = splitpath(dirname(filename))
+    while parts:
+        parents.append(joinpath(parts))
+        parts.pop()
+    return parents
+
+
 try:
     from bzrlib._chunks_to_lines_pyx import chunks_to_lines
 except ImportError:

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2009-05-07 05:08:46 +0000
+++ bzrlib/tests/test_osutils.py	2009-05-18 10:54:13 +0000
@@ -860,6 +860,15 @@
         self.assertRaises(errors.BzrError, osutils.splitpath, 'a/../b')
 
 
+class TestParentDirectories(tests.TestCaseInTempDir):
+    """Test osutils.parent_directories()"""
+
+    def test_parent_directories(self):
+        self.assertEqual([], osutils.parent_directories('a'))
+        self.assertEqual(['a'], osutils.parent_directories('a/b'))
+        self.assertEqual(['a/b', 'a'], osutils.parent_directories('a/b/c'))
+
+
 class TestMacFuncsDirs(tests.TestCaseInTempDir):
     """Test mac special functions that require directories."""
 

